//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  Red
#property indicator_color2  Red
#property indicator_color3  Gold
#property indicator_color4  DodgerBlue
#property indicator_color5  DodgerBlue
#property indicator_color6  Aqua
#property indicator_width1  1
#property indicator_width2  1
#property indicator_style3  STYLE_DASH 
#property indicator_width4  1
#property indicator_width5  1
#property indicator_style6  STYLE_DASH 

//
//
//
//
//

extern string TimeFrame            = "Current time frame";
extern int    LongBandsPeriod      = 50;
extern int    LongBandsMode        = 0;
extern int    LongBandsPrice       = 0;
extern double LongBandsDeviations  = 1.25;
extern int    ShortBandsPeriod     = 20;
extern int    ShortBandsMode       = 0;
extern int    ShortBandsPrice      = 0;
extern double ShortBandsDeviations = 3.25;
extern bool   alertsOn             = true;
extern bool   alertsOnCurrent      = true;
extern bool   alertsMessage        = true;
extern bool   alertsSound          = false;
extern bool   alertsNotify         = true;
extern bool   alertsEmail          = true;
extern string soundFile            = "alert2.wav"; 

//
//
//
//
//

double LongBollUp[];
double LongBollDn[];
double LongBollMd[];
double ShortBollUp[];
double ShortBollDn[];
double ShortBollMd[];
double trend[];
int    timeFrame;

//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,LongBollUp); 
   SetIndexBuffer(1,LongBollDn); 
   SetIndexBuffer(2,LongBollMd); 
   SetIndexBuffer(3,ShortBollUp);
   SetIndexBuffer(4,ShortBollDn);
   SetIndexBuffer(5,ShortBollMd);
   SetIndexBuffer(6,trend);
   
   timeFrame = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" Bandsx2");
   return(0);
  }
  
//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//

int deinit()
{
return(0);
}

//+------------------------------------------------------------------+
//|                             
//+------------------------------------------------------------------+
//
//

int start()
  {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit=MathMax(Bars-counted_bars,3*timeFrame/Period());
            
   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--) 
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      double LongStdDev  = iStdDev(NULL,timeFrame,LongBandsPeriod, 0,LongBandsMode, LongBandsPrice, y); 
      double ShortStdDev = iStdDev(NULL,timeFrame,ShortBandsPeriod,0,ShortBandsMode,ShortBandsPrice,y); 

      LongBollMd[i]  = iMA(NULL,timeFrame,LongBandsPeriod, 0,LongBandsMode, LongBandsPrice, y);
      ShortBollMd[i] = iMA(NULL,timeFrame,ShortBandsPeriod,0,ShortBandsMode,ShortBandsPrice,y);
      LongBollUp[i]  = LongBollMd[i]+(LongStdDev*LongBandsDeviations);
      LongBollDn[i]  = LongBollMd[i]-(LongStdDev*LongBandsDeviations);
      ShortBollUp[i] = ShortBollMd[i]+(ShortStdDev*ShortBandsDeviations);
      ShortBollDn[i] = ShortBollMd[i]-(ShortStdDev*ShortBandsDeviations);
         
         //
         //
         //
         //
         //
         
         trend[i] = trend[i+1];
         if (ShortBollMd[i]>LongBollMd[i]) trend[i] = 1;
         if (ShortBollMd[i]<LongBollMd[i]) trend[i] =-1;
   }
manageAlerts();
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar)); 
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1)  doAlert(whichBar,"crossing up");
         if (trend[whichBar] ==-1)  doAlert(whichBar,"crossing down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Bands x2 ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Bands x2 " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Bands x2 "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}


